<?php
/**
 * Conversios Software
 *
 * @category Conversios
 * @package Conversios_GoogleAnalyticsAndShoppingIntegration
 * @author Conversios
 * @copyright Copyright (c)  Conversios Analytics LLC (https://conversios.io/)
 */
namespace Conversios\GoogleAnalyticsAndShoppingIntegration\Block\Adminhtml;

use Conversios\GoogleAnalyticsAndShoppingIntegration\Helper\CustomApi;
use Conversios\GoogleAnalyticsAndShoppingIntegration\Helper\Data;

class Product extends \Magento\Backend\Block\Widget\Container
{
    /**
     * @var string
     */
    protected $_template = 'product/product.phtml';

    /**
     * @var Data
     */
    public $_helper;

    /**
     * $customHelper variable
     *
     * @var [type]
     */
    protected $customHelper;

    /**
     *
     * @param \Magento\Backend\Block\Widget\Context $context
     * @param CustomApi $customHelper
     * @param Data $helper
     * @param array $data
     */
    public function __construct(
        \Magento\Backend\Block\Widget\Context $context, 
        CustomApi $customHelper,
        Data $helper,
        array $data = []
        )
    {
        $this->customHelper = $customHelper;
        $this->_helper = $helper;
        parent::__construct($context, $data);
    }

    /**
     * @return \Magento\Backend\Block\Widget\Container
     * @throws \Magento\Framework\Exception\LocalizedException
     */
    protected function _prepareLayout()
    {
        
        $this->setChild(
            'grid',
            $this->getLayout()->createBlock('Conversios\GoogleAnalyticsAndShoppingIntegration\Block\Adminhtml\Product\Grid', 'tatvic.product.grid')
        );

        return parent::_prepareLayout();
    }

    /**
     * @return array
     */
    protected function _getAddButtonOptions()
    {
        $splitButtonOptions[] = [
            'label' => __('Sync Products List'),
            'onclick' => "setLocation('#')"
        ];

        return $splitButtonOptions;
    }

    /**
     * Render grid
     *
     * @return string
     */
    public function getGridHtml()
    {
        return $this->getChildHtml('grid');
    }

    /**
     *
     * @return void
     */
    public function getSubscriptionId(){
        return $this->_helper->getSubscriptionId();
    }
}
