<?php
/**
 * Conversios Software
 *
 * @category Conversios
 * @package Conversios_GoogleAnalyticsAndShoppingIntegration
 * @author Conversios
 * @copyright Copyright (c)  Conversios Analytics LLC (https://conversios.io/)
 */
namespace Conversios\GoogleAnalyticsAndShoppingIntegration\Block\Adminhtml\Product\Renderer;

class Image extends \Magento\Backend\Block\Widget\Grid\Column\Renderer\AbstractRenderer
{
    /**
     * Store Manager propery variable
     *
     * @var [type]
     */
    protected $_storeManager;

    /**
     * Conncetion resorce
     *
     * @var [type]
     */
    protected $_resources;

    /**
     * Image render class
     *
     * @param \Magento\Backend\Block\Context $context
     * @param \Magento\Store\Model\StoreManagerInterface $storeManager
     * @param array $data
     */
    public function __construct(
        \Magento\Backend\Block\Context $context,
        \Magento\Store\Model\StoreManagerInterface $storeManager,
        array $data = []
    ) {
        parent::__construct($context, $data);
        $this->_storeManager = $storeManager;
        $this->_resources = \Magento\Framework\App\ObjectManager::getInstance()->get('Magento\Framework\App\ResourceConnection');
    }
    
    /**
     * Render Image URL 
     *
     * @param \Magento\Framework\DataObject $row
     * @return void
     */
    public function render(\Magento\Framework\DataObject $row)
    {
        $connection = $this->_resources->getConnection();
        $allData = "SELECT * FROM `product_sync_list` WHERE `id` = ".$row->getId();
        $allData = $connection->fetchAll($allData);
        $imageUrl = $allData[0]['imageLink'];
        $img = '';
        if($imageUrl != ''){
            $img = '<img src="'.$imageUrl.'" width="80" height="80"/>';
        }else{
            $img = '<img src="" width="80" height="80"/>';
        }
        return $img;
    }
}
