<?php
/**
 * Conversios Software
 *
 * @category Conversios
 * @package Conversios_GoogleAnalyticsAndShoppingIntegration
 * @author Conversios
 * @copyright Copyright (c)  Conversios Analytics LLC (https://conversios.io/)
 */
namespace Conversios\GoogleAnalyticsAndShoppingIntegration\Controller\Adminhtml\CategoryMapping;

use Conversios\GoogleAnalyticsAndShoppingIntegration\Helper\Data;
use Magento\Framework\Controller\Result\JsonFactory;
use \Magento\Framework\App\Action\Action;
use \Magento\Framework\App\Action\Context;
use \Magento\Framework\View\Result\PageFactory;

class Index extends Action
{

    /**
     * @var \Magento\Framework\App\Action\Contex
     */
    private $context;

    /**
     * @var PageFactory
     */
    protected $resultPageFactory;

    protected $resultJsonFactory;

    protected $domainPath;

    protected $_helper;

    /**
     * Result constructor.
     * @param Context $context
     * @param PageFactory $pageFactory
     */
    public function __construct(
        Context $context,
        PageFactory $pageFactory,
        JsonFactory $resultJsonFactory,
        \Psr\Log\LoggerInterface $logger,
        Data $helper
    ) {
        $this->resultPageFactory = $pageFactory;
        $this->context = $context;
        $this->resultJsonFactory = $resultJsonFactory;
        $this->logger = $logger;
        //$this->domainPath = "http://149.28.135.187/tatvic-gmc-middletier/public/api";
        $this->_helper = $helper;
        parent::__construct($context);
    }

    /**
     * The controller action
     *
     * @return \Magento\Framework\View\Result\Page
     */
    public function execute()
    {
        try {
            $countryCode = $this->getRequest()->getParam('countryCode');
            $customerId = $this->getRequest()->getParam('customerId');
            $result = $this->resultJsonFactory->create();

            $header = array(
                "Authorization:Bearer MTIzNA==",
                "content-type:application/json",
            );

            $curl_url = $this->_helper->getApiUrl() . "/products/gmc-categories";

            $data = [
                'customer_id' => $customerId,
                'country_code' => $countryCode,
                'parent' => '',
            ];

            $postData = json_encode($data);
            $ch = curl_init();
            curl_setopt_array($ch, array(
                CURLOPT_URL => $curl_url,
                CURLOPT_RETURNTRANSFER => true,
                CURLOPT_HTTPHEADER => $header,
                CURLOPT_POSTFIELDS => $postData,
            ));
            $response = curl_exec($ch);
            $response = json_decode($response);

            $result->setData($response);
            return $result;
        } catch (\Exception $e) {
            $this->logger->critical($e->getMessage());
        }
    }
}
