<?php

/**
 * Conversios Software
 *
 * @category Conversios
 * @package Conversios_GoogleAnalyticsAndShoppingIntegration
 * @author Conversios
 * @copyright Copyright (c)  Conversios Analytics LLC (https://conversios.io/)
 */

namespace Conversios\GoogleAnalyticsAndShoppingIntegration\Controller\Adminhtml\TruncateData;

use Magento\Backend\App\Action\Context;
use Magento\Framework\Controller\Result\JsonFactory;

class Index extends \Magento\Backend\App\Action
{
    /**
     * $objectManager variable
     *
     * @var ObjectManager
     */
    protected $objectManager;
    /**
     * @var ResourceConnection
     */
    protected $_resources;

    /**
     * $connection
     *
     * @var [void]
     */
    protected $connection;

    /**
     * @var JsonFactory
     */
    protected $resultJsonFactory;

    /**
     * __construct function
     *
     * @param JsonFactory $resultJsonFactory
     * @param Context $context
     */
    public function __construct(
        JsonFactory $resultJsonFactory,
        Context $context
    ) {

        $this->objectManager = \Magento\Framework\App\ObjectManager::getInstance();
        $this->_resources = $this->objectManager->get('Magento\Framework\App\ResourceConnection');
        $this->connection = $this->_resources->getConnection();
        $this->resultJsonFactory = $resultJsonFactory;
        parent::__construct($context);
    }

    /**
     * Index action
     *
     * @return void
     */
    public function execute()
    {
        $this->connection->truncateTable('pre_sync_data');
        $response = "Products data vanished";
        $result = $this->resultJsonFactory->create();
        return $result->setData($response);
    }
}
