<?php
/**
 * Conversios Software
 *
 * @category Conversios
 * @package Conversios_GoogleAnalyticsAndShoppingIntegration
 * @author Conversios
 * @copyright Copyright (c)  Conversios Analytics LLC (https://conversios.io/)
 */
namespace Conversios\GoogleAnalyticsAndShoppingIntegration\Controller\Adminhtml\ajaxMapData;

use Conversios\GoogleAnalyticsAndShoppingIntegration\Helper\Data;
use Magento\Framework\App\Config\ScopeConfigInterface;
use Magento\Framework\App\Config\Storage\WriterInterface;
use Magento\Framework\Controller\Result\JsonFactory;
use Magento\Framework\Serialize\SerializerInterface;
use \Magento\Framework\App\Action\Action;
use \Magento\Framework\App\Action\Context;
use \Magento\Framework\View\Result\PageFactory;

class Index extends Action
{

    /**
     * @var \Magento\Framework\App\Action\Contex
     */
    private $context;

    /**
     * @var PageFactory
     */
    protected $resultPageFactory;

    protected $resultJsonFactory;

    protected $domainPath;

    protected $_scopeConfig;

    public $storeScope;

    private $logger;

    protected $_helper;

    /**
     * @var SerializerInterface
     */
    protected $serializer;

    /**
     * Result constructor.
     * @param Context $context
     * @param PageFactory $pageFactory
     */
    public function __construct(
        Context $context,
        PageFactory $pageFactory,
        JsonFactory $resultJsonFactory,
        WriterInterface $scopeConfig,
        \Psr\Log\LoggerInterface $logger,
        Data $helper,
        SerializerInterface $serializer,
        ScopeConfigInterface $_scopeConfig
    ) {
        $this->resultPageFactory = $pageFactory;
        $this->context = $context;
        $this->resultJsonFactory = $resultJsonFactory;
        $this->_scopeConfig = $_scopeConfig;
        $this->_configWriter = $scopeConfig;
        $this->_helper = $helper;
        $this->logger = $logger;
        $this->serializer = $serializer;
        parent::__construct($context);
    }

    /**
     * The controller action
     *
     * @return \Magento\Framework\View\Result\Page
     */
    public function execute()
    {
        $formArray = $this->getRequest()->getPost();

        $mappedCatsDB = [];
        $mappedCats = [];
        $mappedAttrs = [];
        $result = $this->resultJsonFactory->create();
        foreach ($formArray as $key => $value) {
            if (preg_match("/^category-/i", $key)) {
                if ($value != '' && $value > 0) {
                    $keyArray = explode("-", $key);
                    $mappedCats[$keyArray[1]] = $value;
                    $mappedCatsDB[$keyArray[1]]['id'] = $value;
                }
                //unset($formArray[$key]);
            }
            if (preg_match("/^category-name-/i", $key)) {
                if ($value != '') {
                    $keyArray = explode("name-", $key);
                    $mappedCatsDB[$keyArray[1]]['name'] = $value;
                }
                //unset($formArray[$key]);
            } else {
                if ($value) {
                    $mappedAttrs[$key] = $value;
                }
            }
        }

        $this->_configWriter->save('tatvic/ee_prod_mapped_cats', $this->serializer->serialize($mappedCatsDB));
        $result->setData($mappedCatsDB);
        return $result;
    }
}
