<?php
/**
 * Conversios Software
 *
 * @category Conversios
 * @package Conversios_GoogleAnalyticsAndShoppingIntegration
 * @author Conversios
 * @copyright Copyright (c)  Conversios Analytics LLC (https://conversios.io/)
 */
namespace Conversios\GoogleAnalyticsAndShoppingIntegration\Controller\Adminhtml\campaignPerformance;

use Magento\Framework\Controller\Result\JsonFactory;
use \Magento\Framework\App\Action\Action;
use \Magento\Framework\App\Action\Context;
use \Magento\Framework\View\Result\PageFactory;
use Conversios\GoogleAnalyticsAndShoppingIntegration\Helper\CustomApi;


class Index extends Action
{
    /**
     * @var PageFactory
     */
    protected $resultPageFactory;

    protected $resultJsonFactory;

    protected $customApi;

    /**
     * Result constructor.
     * @param Context $context
     * @param PageFactory $pageFactory
     */
    public function __construct(
        Context $context,
        PageFactory $pageFactory,
        JsonFactory $resultJsonFactory,
        CustomApi $customApi
    ) {
        $this->resultPageFactory = $pageFactory;
        $this->context = $context;
        $this->resultJsonFactory = $resultJsonFactory;
        $this->customApi = $customApi;
        parent::__construct($context);
    }

    /**
     * The controller action
     *
     * @return \Magento\Framework\View\Result\Page
     */
    public function execute()
    {
        $datas  = $this->getRequest()->getPost();
        $response = $this->customApi->accountPerformance($datas);
        $result = $this->resultJsonFactory->create();
        return $result->setData($response);
    }
}

