<?php
/**
 * Conversios Software
 *
 * @category Conversios
 * @package Conversios_GoogleAnalyticsAndShoppingIntegration
 * @author Conversios
 * @copyright Copyright (c)  Conversios Analytics LLC (https://conversios.io/)
 */
namespace Conversios\GoogleAnalyticsAndShoppingIntegration\Controller\Adminhtml\deleteCampaignPmax;

use Conversios\GoogleAnalyticsAndShoppingIntegration\Helper\Data;
use Magento\Framework\App\Config\ScopeConfigInterface;
use Magento\Framework\App\Config\Storage\WriterInterface;
use Magento\Framework\Controller\Result\JsonFactory;
use Magento\Framework\Serialize\SerializerInterface;
use \Magento\Framework\App\Action\Action;
use \Magento\Framework\App\Action\Context;
use \Magento\Framework\View\Result\PageFactory;
use Conversios\GoogleAnalyticsAndShoppingIntegration\Helper\CustomApi;


class Index extends Action
{
    /**
     * @var PageFactory
     */
    protected $resultPageFactory;

    protected $resultJsonFactory;

    protected $domainPath;

    protected $_scopeConfig;

    public $storeScope;

    protected $_helper;

    /**
     * @var SerializerInterface
     */
    protected $serializer;

    protected $customApi;

    /**
     * Result constructor.
     * @param Context $context
     * @param PageFactory $pageFactory
     */
    public function __construct(
        Context $context,
        PageFactory $pageFactory,
        JsonFactory $resultJsonFactory,
        WriterInterface $scopeConfig,
        \Psr\Log\LoggerInterface $logger,
        Data $helper,
        SerializerInterface $serializer,
        CustomApi $customApi,
        ScopeConfigInterface $_scopeConfig
    ) {
        $this->resultPageFactory = $pageFactory;
        $this->context = $context;
        $this->resultJsonFactory = $resultJsonFactory;
        $this->_scopeConfig = $_scopeConfig;
        $this->_configWriter = $scopeConfig;
        $this->_helper = $helper;
        $this->logger = $logger;
        $this->serializer = $serializer;
        $this->customApi = $customApi;
        parent::__construct($context);
    }

    /**
     * The controller action
     *
     * @return \Magento\Framework\View\Result\Page
     */
    public function execute()
    {
        $datas  = $this->getRequest()->getPost();
        $response = $this->customApi->deleteShoppingCampaignPmax($datas);
        $result = $this->resultJsonFactory->create();
        return $result->setData($response);
    }
}
