<?php

/**
 * Conversios Software
 *
 * @category Conversios
 * @package Conversios_GoogleAnalyticsAndShoppingIntegration
 * @author Conversios
 * @copyright Copyright (c)  Conversios Analytics LLC (https://conversios.io/)
 */

namespace Conversios\GoogleAnalyticsAndShoppingIntegration\Controller\Adminhtml\productsSync;

use Conversios\GoogleAnalyticsAndShoppingIntegration\Helper\Data;
use Exception;
use Magento\Catalog\Helper\Image;
use Magento\Framework\App\Config\ScopeConfigInterface;
use Magento\Framework\App\Config\Storage\WriterInterface;
use Magento\Framework\Controller\Result\JsonFactory;
use Magento\Framework\Module\Dir;
use Magento\Framework\Serialize\SerializerInterface;
use Magento\Framework\Session\SessionManagerInterface;
use Magento\Framework\View\Result\Page;
use \Magento\Catalog\Model\ProductFactory;
use \Magento\Framework\App\Action\Action;
use \Magento\Framework\App\Action\Context;
use \Magento\Framework\View\Result\PageFactory;
class Index extends Action
{
    protected $productFactory;

    protected $_logger;

    protected $limit = 20;

    /**
     * @var Context
     */
    private $context;

    /**
     * @var PageFactory
     */
    protected $resultPageFactory;

    /**
     * @var JsonFactory
     */
    protected $resultJsonFactory;

    /**
     * @var ScopeConfigInterface
     */
    protected $_scopeConfig;

    /**
     * @var
     */
    public $storeScope;

    /**
     * @var Data
     */
    public $_helper;

    /**
     * @var \Magento\Catalog\Model\ResourceModel\Product\CollectionFactory
     */
    protected $_productCollectionFactory;

    protected $access_token;

    protected $refresh_token;

    /**
     * @var \Magento\Framework\Module\Dir\Reader
     */
    protected $moduleReader;

    protected $moduleDir;

    protected $objectManager;

    protected $imageHelper;

    protected $curlClient;

    protected $taxRate;

    protected $taxCalculation;

    protected $productLoader;

    protected $_resources;

    protected $messageManager;

    protected $connection;

    protected $tableData;

    protected $_configWriter;

    protected $shipconfig;

    protected $_sessionManager;
    /**
     * @var SerializerInterface
     */
    protected $serializer;

    protected $curl;

    /**
     * @param Context $context
     * @param PageFactory $pageFactory
     * @param JsonFactory $resultJsonFactory
     * @param WriterInterface $scopeConfig
     * @param \Psr\Log\LoggerInterface $logger
     * @param Data $helper
     * @param ScopeConfigInterface $_scopeConfig
     * @param \Magento\Catalog\Model\ResourceModel\Product\CollectionFactory $productCollectionFactory
     * @param \Magento\Catalog\Model\CategoryFactory $_categoryFactory
     * @param \Magento\Framework\Module\Dir\Reader $moduleReader
     * @param Image $imageHelper
     * @param \Magento\Tax\Api\TaxCalculationInterface $taxRate
     * @param \Magento\Framework\HTTP\Client\Curl $curl
     * @param \Magento\Tax\Model\Calculation $taxCalculation
     * @param \Magento\Framework\Message\ManagerInterface $messageManager
     * @param Dir $moduleDir
     * @param SerializerInterface $serializer
     * @param ProductFactory $productFactory
     * @param Magento\Framework\HTTP\Client\Curl $curl
     * @param SessionManagerInterface $session
     */
    public function __construct(
        Context $context,
        PageFactory $pageFactory,
        JsonFactory $resultJsonFactory,
        WriterInterface $scopeConfig,
        \Psr\Log\LoggerInterface $logger,
        Data $helper,
        ScopeConfigInterface $_scopeConfig,
        \Magento\Catalog\Model\ResourceModel\Product\CollectionFactory $productCollectionFactory,
        \Magento\Catalog\Model\CategoryFactory $_categoryFactory,
        \Magento\Framework\Module\Dir\Reader $moduleReader,
        Image $imageHelper,
        \Magento\Tax\Api\TaxCalculationInterface $taxRate,
        \Magento\Framework\HTTP\Client\Curl $curl,
        \Magento\Tax\Model\Calculation $taxCalculation,
        \Magento\Framework\Message\ManagerInterface $messageManager,
        Dir $moduleDir,
        SerializerInterface $serializer,
        ProductFactory $productFactory,
        SessionManagerInterface $session
    ) {
        $this->objectManager = \Magento\Framework\App\ObjectManager::getInstance();
        $this->resultPageFactory = $pageFactory;
        $this->context = $context;
        $this->curl = $curl;
        $this->resultJsonFactory = $resultJsonFactory;
        $this->_scopeConfig = $_scopeConfig;
        $this->_configWriter = $scopeConfig;
        $this->_helper = $helper;
        $this->_productCollectionFactory = $productCollectionFactory;
        $this->_categoryFactory = $_categoryFactory;
        $this->moduleReader = $moduleReader;
        $this->moduleDir = $moduleDir;
        $this->imageHelper = $imageHelper;
        $this->curlClient = $curl;
        $this->taxRate = $taxRate;
        $this->taxCalculation = $taxCalculation;
        $this->messageManager = $messageManager;
        $this->_resources = $this->objectManager->get('Magento\Framework\App\ResourceConnection');
        $this->connection = $this->_resources->getConnection();
        $this->tableData = $this->_resources->getTableName('`pre_sync_data`');
        $this->tableData2 = $this->_resources->getTableName('`product_sync_data`');
        $this->scopeConfig = $scopeConfig;
        $this->_logger = $logger;
        $this->_sessionManager = $session;
        $this->serializer = $serializer;
        $this->productFactory = $productFactory;
        parent::__construct($context);
    }

    /**
     * The controller action
     *
     * @return \Magento\Framework\View\Result\Page
     */
    public function execute()
    {
        $postDatas = $this->getRequest()->getPost();
        $this->_configWriter->save('tatvic/ee_prod_mapped_attrs', $this->serializer->serialize($postDatas));

        $curl_url = $this->_helper->getApiUrl() . "/products/batch";
        $currency = $this->_helper->getCurrencyCode();
        $entries = [];
        $batchId = time();
        $product_ids = [];
        /* Insert Data Product in Database Table Start*/

        $mappedCategories = $this->_helper->getMappedCategories();
        if ($this->CheckAllData() == true) {
        //$this->DeleteRows();
            $this->storeProductsData($mappedCategories, $this->serializer->serialize($postDatas));
        }

        /* Insert Data Product in Database Table End*/

        try {
            $data = $this->getFirstHundredProducts();
            if ($data) {
                $productsData = array();
                $skipProduct = array();
                foreach ($data as $productData) {
                    $product = $this->productFactory->create()->load($productData['product_id']);

                    if ($product->getTypeId() == 'configurable') {
                        $_children = $product->getTypeInstance(true)->getUsedProducts($product);
                        if ($_children) {
                            foreach ($_children as $child) {

                                $childProduct = $this->productFactory->create()->load($child->getID());
                                $prodData = $childProduct->getData();
                                $id = ($childProduct->getId() != '') ? $childProduct->getId() : $childProduct->getSku();
                                $helperImport = $this->objectManager->get('\Magento\Catalog\Helper\Image');
                                $productsData['content_language'] = !empty($postDatas["content_language"]) ? $postDatas["content_language"] : "en";
                                $productsData['target_country'] = !empty($postDatas["target_country"]) ? $postDatas["target_country"] : $this->getCountry();
                                $productsData['condition'] = !empty($postDatas["condition"]) ? $postDatas["condition"] : "new";
                                $productsData['offer_id'] = (int) $id;
                                $productsData['channel'] = "online";
                                $productsData['item_group_id'] = (int) $product->getId();
                                $productsData['google_product_category'] = (int) $productData['category_id'];
                                $productsData['link'] = $this->objectManager->get('Magento\Store\Model\StoreManagerInterface')->getStore()->getBaseUrl() . $product->getUrlKey() . '.html';
                                $productsData['image_link'] = (string) $helperImport->init($childProduct, 'product_page_image_small')->setImageFile($childProduct->getSmallImage())->resize(380)->getUrl();
                                $productsData['id'] = (int) $id;
                                $productsData['title'] = $childProduct->getName();
                                $productsData['description'] = (string) strip_tags($childProduct->getData('description'));
                                if(!empty($postDatas['brand']) || (!empty($childProduct->getAttributeText('manufacturer'))))
                                {
                                $productsData['brand'] = !empty($postDatas["brand"]) ? (!empty($childProduct->getAttributeText('manufacturer')) ? $childProduct->getAttributeText('manufacturer') : "") : $childProduct->getAttributeText('manufacturer');
                                }
                                $productsData['age_group'] = !empty($postDatas["age_group"]) ? $postDatas["age_group"] : 'adult';
                                $productsData['gender'] = !empty($postDatas["gender"]) ? $postDatas["gender"] : 'male';
                                $productsData['availability'] = ($childProduct->isInStock() == 1) ? "in stock" : "out of stock";

                                if($childProduct->getResource()->getAttribute($postDatas["gtin"]) !="")
                                {
                                $productsData['gtin'] = $childProduct->getResource()->getAttribute($postDatas["gtin"]);
                                }

                                if($childProduct->getResource()->getAttribute($postDatas["mpn"]) !="")
                                {
                                $productsData['mpn'] = $childProduct->getResource()->getAttribute($postDatas["mpn"]);
                                }

                                $productsData['price'] = ["value" => $childProduct->getPrice(), "currency" => $currency];
                                $productsData['sale_price'] = ["value" => $childProduct->getFinalPrice(), "currency" => $currency];
                                $attribute = $childProduct->getResource()->getAttribute('size');
                                $attributeValue = $attribute->getFrontend()->getValue($childProduct);
                                $attribute2 = $childProduct->getResource()->getAttribute('color');
                                $attributeValue2 = $attribute2->getFrontend()->getValue($childProduct);
                                $sizes = !empty($postDatas["sizes"]) ? (!empty($attributeValue) ? $attributeValue : "") : "";
                                $color = !empty($postDatas["color"]) ? (!empty($attributeValue2) ? $attributeValue2 : "") : "";

                                if($color !="")
                                {
                                $productsData['color'] = $color;
                                }

                                if($sizes !="")
                                {
                                $productsData['sizes'] = $sizes;
                                }

                                if(($postDatas['tax'] != "") && ($postDatas['target_country'] !=""))
                                {
                                $productsData['taxes'] = [
                                    "rate" => $postDatas['tax'],
                                    "country" => $postDatas['target_country']
                                ];
                                }elseif ($postDatas['tax'] == ""){
                                    $productsData['taxes'] = [
                                    "country" => $postDatas['target_country']
                                ];
                                }elseif ($postDatas['target_country'] == ""){
                                    $productsData['taxes'] = [
                                    "rate" => $postDatas['tax']
                                ];
                                }

                                if (($postDatas['shipping'] !="") && ($currency !="") && ($postDatas['target_country'] != "")) {
                                    $productsData['shipping'] = array(
                                    "price" => ([
                                        "value" => $postDatas['shipping'],
                                        "currency" => $currency,
                                    ]),
                                    "country" => $postDatas['target_country'],
                                    );
                                }elseif ($postDatas['shipping'] =="") {
                                    $productsData['shipping'] = array(
                                    "price" => ([
                                        "currency" => $currency,
                                                ]),
                                    "country" => $postDatas['target_country'],
                                );
                                }elseif ($currency == "") {
                                    $productsData['shipping'] = array(
                                    "price" => ([
                                        "value" => $postDatas['shipping'],
                                                ]),
                                    "country" => $postDatas['target_country'],
                                    );
                                }elseif ($postDatas['target_country'] =="") {
                                    $productsData['shipping'] = array(
                                    "price" => ([
                                        "value" => $postDatas['shipping'],
                                        "currency" => $currency,
                                    ]),
                                    );
                                }

                                $entrie = [
                                    'method' => 'insert',
                                    'merchant_id' => $this->getMerchantId(),
                                    'batch_id' => ++$batchId,
                                    'product' => $productsData,
                                ];
                                $entries[] = $entrie;
                            }
                        }
                    }//configurable

                    if ($product->getTypeId() == 'simple') {
                        $prodData = $product->getData();
                        $id = ($prodData['entity_id'] != '') ? $prodData['entity_id'] : $prodData['sku'];
                        $helperImport = $this->objectManager->get('\Magento\Catalog\Helper\Image');
                        $productsData['content_language'] = !empty($postDatas["content_language"]) ? $postDatas["content_language"] : "en";
                        $productsData['target_country'] = !empty($postDatas["target_country"]) ? $postDatas["target_country"] : $this->getCountry();
                        $productsData['condition'] = !empty($postDatas["condition"]) ? $postDatas["condition"] : "new";
                        $productsData['offer_id'] = (int) $id;
                        $productsData['channel'] = "online";
                        $productsData['google_product_category'] = (int) $productData['category_id'];
                        $productsData['link'] = $this->objectManager->get('Magento\Store\Model\StoreManagerInterface')->getStore()->getBaseUrl() . $product->getUrlKey() . '.html';
                        $productsData['image_link'] = (string) $helperImport->init($product, 'product_page_image_small')->setImageFile($product->getSmallImage())->resize(380)->getUrl();
                        $productsData['id'] = (int) $id;
                        $productsData['title'] = $prodData['name'];
                        $productsData['description'] = (string) strip_tags($prodData['description']);

                        if(!empty($postDatas["brand"]) && !empty($product->getAttributeText('manufacturer'))){
                            // $productsData['brand'] = !empty($postDatas["brand"]) ? (!empty($product->getAttributeText('manufacturer')) ? $product->getAttributeText('manufacturer') : "") : $product->getAttributeText('manufacturer');
                            $productsData['brand'] = !empty($postDatas["brand"]) ? (!empty($product->getAttributeText('manufacturer'))) : $product->getAttributeText('manufacturer');

                        }

                        // if ($postDatas["age_group"] != "") {
                            $productsData['age_group'] = !empty($postDatas["age_group"]) ? $postDatas["age_group"] : 'adult';
                        // }
                        
                        $productsData['gender'] = !empty($postDatas["gender"]) ? $postDatas["gender"] : 'male';

                        $productsData['availability'] = ($product->isInStock() == 1) ? "in stock" : "out of stock";

                        if ($postDatas["gtin"] !=""){
                            $productsData['gtin'] = $childProduct->getResource()->getAttribute($postDatas["gtin"]);
                        }

                        if ($postDatas["mpn"] != ""){
                            $productsData['mpn'] = $childProduct->getResource()->getAttribute($postDatas["mpn"]);
                        }

                        if(($postDatas['tax'] != "") && ($postDatas['target_country'] !="")){
                            $productsData['taxes'] = [
                                "rate" => $postDatas['tax'],
                                "country" => $postDatas['target_country']
                            ];
                        }elseif ($postDatas['tax'] == ""){
                            $productsData['taxes'] = [
                                "country" => $postDatas['target_country']
                            ];
                        }elseif ($postDatas['target_country'] == ""){
                                $productsData['taxes'] = [
                                "rate" => $postDatas['tax']
                            ];
                        }

                        //$productsData['taxes'] = ["rate" => $postDatas['tax'], "country" => $postDatas['target_country']];

                        if (($postDatas['shipping'] !="") && ($currency !="") && ($postDatas['target_country'] != "")) {
                            $productsData['shipping'] = array(
                                "price" => ([
                                    "value" => $postDatas['shipping'],
                                    "currency" => $currency,
                                ]),
                                "country" => $postDatas['target_country']
                            );
                        }elseif ($postDatas['shipping'] =="") {
                            $productsData['shipping'] = array(
                                "price" => ([
                                "currency" => $currency,
                                            ]),
                                "country" => $postDatas['target_country']
                            );
                        }elseif ($currency == "") {
                            $productsData['shipping'] = array(
                                "price" => ([
                                "value" => $postDatas['shipping'],
                                        ]),
                                "country" => $postDatas['target_country']
                            );
                        }elseif ($postDatas['target_country'] =="") {
                            $productsData['shipping'] = array(
                                "price" => ([
                                    "value" => $postDatas['shipping'],
                                    "currency" => $currency,
                                ])
                            );
                        }

                        // $productsData['shipping'] = array(
                        //     "price" => ([
                        //         "value" => $postDatas['shipping'],
                        //         "currency" => $currency,
                        //     ]),
                        //     "country" => $postDatas['target_country'],
                        // );

                        $attribute = $product->getResource()->getAttribute('size');
                        $attributeValue = $attribute->getFrontend()->getValue($product);
                        $attribute2 = $product->getResource()->getAttribute('color');
                        $attributeValue2 = $attribute2->getFrontend()->getValue($product);
                        $sizes = !empty($postDatas["sizes"]) ? (!empty($attributeValue) ? $attributeValue : "") : "";
                        // if($postDatas["color"] !="")
                        // {
                        $color = !empty($postDatas["color"]) ? (!empty($attributeValue2) ? $attributeValue2 : "") : "";
                        // }
                        // echo "Testing Data 122";exit;
                        if ($product->getFinalPrice() > 0) {
                            $price = !empty($product->getFinalPrice()) ? $product->getFinalPrice() : $prodData['price'];
                            $productsData['price'] = ["value" => $price, "currency" => $currency];
                        }
                        $productsData['link'] = $this->objectManager->get('Magento\Store\Model\StoreManagerInterface')->getStore()->getBaseUrl().$product->getUrlKey().'.html';
                        if ($product->getSpecialPrice() > 0) {
                            $specialPrice = !empty($product->getSpecialPrice()) ? $product->getSpecialPrice() : $prodData['price'];
                            $productsData['sale_price'] = ["value" => number_format($specialPrice, 2), "currency" => $currency];
                        }

                        if($color !=""){
                            $productsData['color'] = $color;
                        }

                        if($sizes !=""){
                            $productsData['sizes'] = $sizes;
                        }
                        $entrie = [
                            'method' => 'insert',
                            'merchant_id' => $this->getMerchantId(),
                            'batch_id' => ++$batchId,
                            'product' => $productsData,
                        ];
                        $entries[] = $entrie;
                    } //simple
                    $product_ids[] = $productData['product_id'];
                    if(count($entries) >= $this->limit){
                        break;
                    }
                }

                // print_r($entries);
                // exit;

                $total_product = $this->GetAllProducts();
                // print_r($total_product);
                $product_batch_size = $this->limit;
                // echo "=====>";print_r($product_batch_size);
                $sync_produt = $this->getSyncedProducts();
                // print_r($sync_produt);
                $sync_produt_p = "";
                $is_synced_up = "";
                $sync_message = "";

                if ($total_product != '0') {
                    
                    if (!empty($postDatas)) {
                        $sync_progressive_data = isset($postDatas['sync_progressive_data']) ? $postDatas['sync_progressive_data'] : "";
                        $sync_step = isset($sync_progressive_data['sync_step']) ? $sync_progressive_data['sync_step'] : "1";

                        if ($total_product >= $sync_produt && $sync_step == 1) {
                            $sync_step = 2;
                            $sync_produt = 0;
                        }

                        if ($sync_step == 1) {
                            //echo "Enter into sync step 1";
                            $sync_produt = (int) $sync_produt + $product_batch_size;
                            $sync_produt_p = ((int) $sync_produt * 100) / $total_product;
                            $is_synced_up = ($total_product <= $sync_produt) ? true : false;
                            $sync_message = "Initialization of products data for push data in Google shopping"; //"Initialization of products data for push data in Google shopping";
                        } else if ($sync_step == 2) {
                            //echo "Enter into sync step 1";
                            //$sync_produt = (int) $sync_produt + $product_batch_size;
                            $sync_produt = (int) $sync_produt + count($product_ids);
                            $sync_produt_p = ((int) $sync_produt * 100) / $total_product;
                            $is_synced_up = ($total_product <= $sync_produt) ? true : false;
                            $sync_message = "Now products are adding in Google shopping";
                        }
                    }

                    $datas = [
                        'subscription_id' => $this->getSubscriptionId(),
                        'merchant_id' => $this->getAccountId(),
                        'account_id' => $this->getMerchantId(),
                        'entries' => $entries,
                    ];
                   //print_r($datas);

                    $postData = json_encode($datas);
                    $header = [
                        "Authorization: Bearer MTIzNA==",
                        "content-type: application/json",
                        "AccessToken: " . $this->generateAccessToken($this->_helper->getAccessToken(), $this->_helper->getRefreshToken()),
                    ];
                    //print_r($header);
                    $ch = curl_init();
                    curl_setopt_array($ch, array(
                        CURLOPT_URL => $curl_url, //esc_url($this->curl_url),
                        CURLOPT_RETURNTRANSFER => true,
                        CURLOPT_TIMEOUT => 100000,
                        CURLOPT_HTTPHEADER => $header,
                        CURLOPT_POSTFIELDS => $postData,
                    ));
                    $server_output = curl_exec($ch);
                    $sync_produt = json_decode($server_output);
                     //print_r($sync_produt);
                    if (!empty($sync_produt->data)) {
                        $sync_produt = count($sync_produt->data->entries);
                        // print_r($sync_produt);exit;
                        if ($sync_produt_p > 100) {
                            $sync_produt_p = 100;
                        }
                       // $sync_progressive_data = array("sync_step" => $sync_step, "total_product" => $total_product, "sync_produt" => $sync_produt, "sync_produt_p" => $sync_produt_p, "is_synced_up" => $is_synced_up, "sync_message" => $sync_message);
                        $sync_progressive_data = array("sync_step" => $sync_step, "total_product" => $total_product, "sync_produt" => count($product_ids),"product_ids" => $product_ids, "sync_produt_p" => $sync_produt_p, "is_synced_up" => $is_synced_up, "sync_message" => $sync_message);

                        $response = array( 'status' => 'success', 'skipProducts' => count($skipProduct), "sync_progressive_data" => $sync_progressive_data );                        

                        $this->UpdateRows($product_ids);

                        if ($is_synced_up == true) {
                            $this->DeleteRows();
                        }
                        $result = $this->resultJsonFactory->create();
                        return $result->setData($response);
                    } else {
                        $result = $this->resultJsonFactory->create();
                        return $result->setData($sync_produt);
                    }
                }
            }
        } catch (Exception $e) {
            $result = $this->resultJsonFactory->create();
            return $result->setData("Unexpected Error!");
        }
    }

    public function storeProductsData($mappedCategories, $postDatas)
    {
        try {
            if (is_array($mappedCategories)) {
                foreach ($mappedCategories as $categoryId => $mappedCat) {
                    $mappedCat = !empty($mappedCat['id']) ? $mappedCat['id'] : $mappedCat['name'];
                    $category = $this->_categoryFactory->create()->load($categoryId);
                    $collection = $this->_productCollectionFactory->create();
                    $collection->addAttributeToSelect('*');
                    $collection->addCategoryFilter($category)->load();
                    foreach ($collection as $product) {
                        $prodData = $product->getData();
                        $updateDate = date('Y-m-d', strtotime(' +25 day'));
                        $fetchData = $this->getSyncDataRow($prodData['entity_id']);
                        if (empty($fetchData)) {
                            $insertData = "INSERT INTO " . $this->tableData2 . " (`product_id`,`cat_id`,`gmc_cat_id`,`attribute_mapping`,`update_date`,`created_date`) VALUES (" . $prodData['entity_id'] . ", " . $categoryId . ", " . $mappedCat . ",'" . $postDatas . "','" . $updateDate . "','" . date('Y-m-d') . "')";
                            $this->connection->query($insertData);
                        } else {
                            $updateData = "UPDATE " . $this->tableData2 . " SET update_date = '" . $updateDate . "' WHERE product_id = " . $prodData['entity_id'];
                            $this->connection->exec($updateData);
                        }
                        $sql = "INSERT INTO " . $this->tableData . " (`product_id`,`category_id`,`profile`,`update`,`status`) VALUES (" . $prodData['entity_id'] . ", '" . $mappedCat . "', 1," . date('Y-m-d') . ", 1)";
                        $this->connection->query($sql);
                    }
                }
            }
        } catch (Exception $e) {
            $result = $this->resultJsonFactory->create();
            return $result->setData($e->getMessage());
        }
    }

    public function CheckAllData()
    {
        $getData = "SELECT * FROM " . $this->tableData." where status = 1" ;
        $allData = $this->connection->fetchAll($getData);
        if (empty($allData)) {
            $this->DeleteRows();
            return true;
        } else {
            return false;
        }
    }

    public function getFirstHundredProducts()
    {
        $getData = "SELECT * FROM " . $this->tableData . " WHERE status = 1 ORDER BY id ASC LIMIT " . $this->limit;
        return $this->connection->fetchAll($getData);
    }

    public function getSyncedProducts()
    {
        $rows = "SELECT * FROM " . $this->tableData . " WHERE status = 0 ORDER BY id ASC";
        $allData = $this->connection->fetchAll($rows);
        return count($allData);
    }

    public function GetAllProducts()
    {
        $getData = "SELECT * FROM " . $this->tableData;
        $allData = $this->connection->fetchAll($getData);
        //echo "<br/>";print_r($allData);exit;
        return count($allData);
    }

    public function getSyncDataRow($productId)
    {
        $row = "SELECT * FROM " . $this->tableData2 . " WHERE product_id = " . $productId;
        return $this->connection->fetchAll($row);
    }

    public function UpdateRows($product_ids)
    {
        //$updateData = "UPDATE " . $this->tableData . " SET status = 0 WHERE status = 1 and product_id in ('".$product_ids."') ORDER BY id ASC LIMIT " . $this->limit;
        $updateData = "UPDATE " . $this->tableData . " SET status = 0 WHERE status = 1 and product_id in ('". implode("', '",$product_ids)."')";
        $this->connection->exec($updateData);
    }

    public function DeleteRows()
    {
        $this->connection->truncateTable('pre_sync_data');
    }

    /**
     * @return Curl
     */
    public function getCurlClient()
    {
        return $this->curlClient;
    }

    public function getMerchantId()
    {
        return $this->_helper->getMerchantId();
    }

    public function getSubscriptionId()
    {
        return $this->_helper->getSubscriptionId();
    }
    public function getCustomerId()
    {
        return $this->_helper->getCustomerId();
    }
    public function getAccountId()
    {
        return $this->_helper->getAccountId();
    }

    public function storeCurrency()
    {
        return $this->_helper->getCurrencyCode();
    }

    public function getCountry()
    {
        return $this->_helper->getCountry();
    }

    /**
     * @param [type] $access_token
     * @param [type] $refresh_token
     * @return void
     */
    public function generateAccessToken($access_token, $refresh_token)
    {
        $request = "https://www.googleapis.com/oauth2/v1/tokeninfo?access_token=" . $access_token;

        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $request);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
        $response = curl_exec($ch);
        $result = json_decode($response);

        if (isset($result->error) && $result->error == 'invalid_token') {
            $modulePath = $this->moduleDir->getDir('Conversios_GoogleAnalyticsAndShoppingIntegration');
            $secretFile = $modulePath . '/Helper/Json/client-secrets.json'; //your file path
            $credentials_file = $secretFile;
            $str = file_get_contents($credentials_file);
            $credentials = $str ? json_decode($str, true) : [];
            $url = 'https://www.googleapis.com/oauth2/v4/token';
            $header = array("content-type: application/json");
            $clientId = $credentials['web']['client_id'];
            $clientSecret = $credentials['web']['client_secret'];
            $refreshToken = $refresh_token;
            $data = [
                "grant_type" => 'refresh_token',
                "client_id" => $clientId,
                'client_secret' => $clientSecret,
                'refresh_token' => $refreshToken,
            ];

            $postData = json_encode($data);
            $ch = curl_init();
            curl_setopt_array($ch, array(
                CURLOPT_URL => $url, //esc_url($this->curl_url),
                CURLOPT_RETURNTRANSFER => true,
                CURLOPT_TIMEOUT => 1000,
                CURLOPT_HTTPHEADER => $header,
                CURLOPT_POSTFIELDS => $postData,
            ));
            $response = curl_exec($ch);
            $response = json_decode($response);
            return $response->access_token;
        } else {
            return $access_token;
        }
    }

    public function get_tvc_access_token()
    {
        if (!empty($this->access_token)) {
            return $this->access_token;
        } else {
            return $this->_helper->getAccessToken();
        }
    }

    public function get_tvc_refresh_token()
    {
        if (!empty($this->refresh_token)) {
            return $this->refresh_token;
        } else {
            return $this->_helper->getRefreshToken();
        }
    }
}
