<?php
/**
 * Conversios Software
 * @category Conversios
 * @package Conversios_GoogleAnalyticsAndShoppingIntegration
 * @author Conversios
 * @copyright Copyright (c)  Conversios Analytics LLC (https://conversios.io/)
 */

namespace Conversios\GoogleAnalyticsAndShoppingIntegration\Model;

use PHPUnit\Framework\Exception;
use \Magento\Framework\App\Config\Value;
use Magento\Framework\App\Config\ScopeConfigInterface;
use Magento\Framework\App\Config\Storage\WriterInterface;
use Magento\Framework\Message\MessageInterface;

class Code extends Value
{
    /**
     * @var \Magento\Framework\Session\Config\Validator\CookieLifetimeValidator
     */
    protected $configValidator;

    protected $_configWriter;

    protected $_scopeConfig;

    protected $storeScope;

    /**
     * Code constructor.
     * @param \Magento\Framework\Model\Context $context
     * @param \Magento\Framework\Registry $registry
     * @param \Magento\Framework\App\Config\ScopeConfigInterface $config
     * @param \Magento\Framework\App\Cache\TypeListInterface $cacheTypeList
     * @param \Magento\Framework\Session\Config\Validator\CookieLifetimeValidator $configValidator
     * @param \Magento\Framework\Model\ResourceModel\AbstractResource|null $resource
     * @param \Magento\Framework\Data\Collection\AbstractDb|null $resourceCollection
     * @param array $data
     */
    public function __construct(
        \Magento\Framework\Model\Context $context,
        \Magento\Framework\Registry $registry,
        \Magento\Framework\App\Config\ScopeConfigInterface $config,
        \Magento\Framework\App\Cache\TypeListInterface $cacheTypeList,
        \Magento\Framework\Session\Config\Validator\CookieLifetimeValidator $configValidator,
        \Magento\Framework\Model\ResourceModel\AbstractResource $resource = null,
        \Magento\Framework\Data\Collection\AbstractDb $resourceCollection = null,
        WriterInterface $scopeConfig,
        ScopeConfigInterface $_scopeConfig,
        array $data = []
    ) {
        $this->configValidator = $configValidator;
        $this->_configWriter = $scopeConfig;
        $this->_scopeConfig = $_scopeConfig;
        $this->storeScope = \Magento\Store\Model\ScopeInterface::SCOPE_STORE;
        parent::__construct($context, $registry, $config, $cacheTypeList, $resource, $resourceCollection, $data);
    }

    /**
     * @return \Magento\Framework\App\Config\Value
     * @throws \Exception
     */

    public function beforeSave()
    {
        try {
            $value = $this->getValue();

            if(!preg_match("/^([a-z0-9]{32})$/im", $value)){
                throw new \Exception('Invalid Activation Code,Please enter correct code!');
            }else{
                return parent::beforeSave();
            }
        }catch (Exception $e){
            throw new \Exception('Invalid Activation Code,Please enter correct code!');
        }
    }
}
