/**
 * Copyright © 2020 Wyomind. All rights reserved.
 * See LICENSE.txt for license details.
 */
require([
  "jquery",
  "mage/mage",
  "jquery/ui",
  "Magento_Ui/js/modal/modal",
  "Magento_Ui/js/modal/confirm",
], function ($, mage, ui, modal, confirm) {
  /*"use strict";*/

  var options = {
    type: "slide",
    responsive: true,
    innerScroll: true,
    title: "Map your product attributes",
    modalClass: "first-modal",
    buttons: [
      {
        text: $.mage.__("Next"),
        class: "next-btn attribute-map-save primary",
        click: function () {
          this.openModal();
        },
      },
    ],
  };

  var slide_option = {
    type: "slide",
    responsive: true,
    innerScroll: true,
    title: "Map your product attributes",
    modalClass: "second-modal",
    buttons: [
      {
        text: $.mage.__("Previous"),
        class: "prev-btn action",
        click: function () {
          this.closeModal();
        },
      },
      {
        text: $.mage.__("Sync Products"),
        class: "sync-btn sync-mapped-products primary",
        click: function () {
          this.openModal();
        },
      },
    ],
  };

  modal(options, $("#popup-modal"));
  modal(slide_option, $("#slide-modal"));
  $("#product-sync-pop").click(function () {
    if (window.navigator.onLine === false) {
      return false;
    } else {
      jQuery("body").loader("show");
      $("#popup-modal").modal("openModal");
    }
  });
  $(".next-btn").click(function () {
    $("#slide-modal").modal("openModal");
  });
  $(".prev-btn").click(function () {
    $("#popup-modal").modal("openModal");
  });

  $("#order-view-add-warranty").click(function () {
    $("#order-view-add-warranty-form").append(
      $("<input>", {
        name: "form_key",
        value: window.FORM_KEY,
        type: "hidden",
      })
    );
    $("#order-view-add-warranty-form").submit();
  });

  $("#popup-modal").on("click", ".change_prodct_feed_cat", function () {
    $(this).hide();
    var feed_select_cat_id = $(this).attr("data-id");
    var woo_cat_id = $(this).attr("data-cat-id");

    jQuery("#category-" + woo_cat_id).val("0");
    jQuery("#category-name-" + woo_cat_id).val("");
    jQuery("#label-" + feed_select_cat_id).hide();
    jQuery("#" + feed_select_cat_id)
      .slideDown()
      .addClass("select admin__control-select")
      .css("width", "75% !important");
  });
});
